Package com.opensymphony.module.sitemesh.util

# Class CharArrayReader

java.lang.Object
java.io.Reader
com.opensymphony.module.sitemesh.util.CharArrayReader

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`, `Readable`

public class CharArrayReader extends Reader
This class implements a character buffer that can be used as a character-input stream. Modified from the JDK source in that it gets rid of the ensureOpen() method, so we get unexpected behaviour if the reader is closed.

The second modification is that since this class is used internally by FastPageParser in a single thread, we don't need any locking or synchronization. Using this class instead of the standard CharArrayReader improves FastPageParser performance by 15-20%.

Author:
  Hani Suleiman

## Field Summary

Fields
Modifier and Type
Field
Description
`protected char[]`
`buf`
The character buffer.
`protected int`
`count`
The index of the end of this buffer.
`protected int`
`markedPos`
The position of mark in buffer.
`protected int`
`pos`
The current buffer position.

### Fields inherited from class java.io.Reader

`lock`

## Constructor Summary

Constructors
Constructor
Description
`CharArrayReader(char[] buf)`
Create an CharArrayReader from the specified array of chars.
`CharArrayReader(char[] buf, int offset, int length)`
Create an CharArrayReader from the specified array of chars.

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Close the stream.
`void`
`mark(int readAheadLimit)`
Mark the present position in the stream.
`boolean`
`markSupported()`
Tell whether this stream supports the mark() operation, which it does.
`int`
`read()`
Read a single character.
`int`
`read(char[] b, int off, int len)`
Read characters into a portion of an array.
`boolean`
`ready()`
Tell whether this stream is ready to be read.
`void`
`reset()`
Reset the stream to the most recent mark, or to the beginning if it has never been marked.
`long`
`skip(long n)`
Skip characters.

### Methods inherited from class java.io.Reader

`nullReader, read, read, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### buf

protected char[] buf
The character buffer.

### pos

protected int pos
The current buffer position.

### markedPos

protected int markedPos
The position of mark in buffer.

### count

protected int count
The index of the end of this buffer. There is not valid data at or beyond this index.

## Constructor Details

### CharArrayReader

public CharArrayReader(char[] buf)
Create an CharArrayReader from the specified array of chars.

Parameters:
  `buf` - Input buffer (not copied)

### CharArrayReader

public CharArrayReader(char[] buf, int offset, int length)
Create an CharArrayReader from the specified array of chars.

Parameters:
  `buf` - Input buffer (not copied)
  `offset` - Offset of the first char to read
  `length` - Number of chars to read

## Method Details

### read

public int read() throws IOException
Read a single character.

Overrides:
  `read` in class `Reader`
Throws:
  `IOException` - If an I/O error occurs

### read

public int read(char[] b, int off, int len) throws IOException
Read characters into a portion of an array.

Specified by:
  `read` in class `Reader`
Parameters:
  `b` - Destination buffer
  `off` - Offset at which to start storing characters
  `len` - Maximum number of characters to read
Returns:
  The actual number of characters read, or -1 if the end of the stream has been reached
Throws:
  `IOException` - If an I/O error occurs

### skip

public long skip(long n) throws IOException
Skip characters.

Overrides:
  `skip` in class `Reader`
Parameters:
  `n` - The number of characters to skip
Returns:
  The number of characters actually skipped
Throws:
  `IOException` - If an I/O error occurs

### ready

public boolean ready() throws IOException
Tell whether this stream is ready to be read. Character-array readers are always ready to be read.

Overrides:
  `ready` in class `Reader`
Throws:
  `IOException` - If an I/O error occurs

### markSupported

public boolean markSupported()
Tell whether this stream supports the mark() operation, which it does.

Overrides:
  `markSupported` in class `Reader`

### mark

public void mark(int readAheadLimit) throws IOException
Mark the present position in the stream. Subsequent calls to reset() will reposition the stream to this point.

Overrides:
  `mark` in class `Reader`
Parameters:
  `readAheadLimit` - Limit on the number of characters that may be read while still preserving the mark. Because the stream's input comes from a character array, there is no actual limit; hence this argument is ignored.
Throws:
  `IOException` - If an I/O error occurs

### reset

public void reset() throws IOException
Reset the stream to the most recent mark, or to the beginning if it has never been marked.

Overrides:
  `reset` in class `Reader`
Throws:
  `IOException` - If an I/O error occurs

### close

public void close()
Close the stream.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in class `Reader`